import java.io.*;
import java.util.*;
import java.util.jar.*;

class Main {
    public static void main(String[] args) {
        if (args.length < 3) {
            System.out.println("Usage: java Main <jar-file> <manifest> <file1>...");
            System.exit(1);
        }

        try {
            Manifest man = new Manifest(new FileInputStream(args[1]));
            for (Iterator it=man.getEntries().keySet().iterator(); it.hasNext(); ) {
                System.out.println(it.next());
            }
        
            JarOutputStream jos = new JarOutputStream(
                new FileOutputStream(args[0]), man);

           byte[] buf = new byte[1024];
           int len;
           for (int i=2; i<args.length; i++) {
                File f = new File(args[i]);
                FileInputStream fis = new FileInputStream(f);
                JarEntry je = new JarEntry(convertToZIPName(f));
                jos.putNextEntry(je);
                // Now read and write the zip entry data.
                while ((len = fis.read(buf)) >= 0) {
                    jos.write(buf, 0, len);
                }

            }
            jos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // Converts f's pathname to a form acceptable to ZIP files.
    static String convertToZIPName(File f) throws IOException {
        return f.getCanonicalPath().replace(File.separatorChar, '/');
    }
}
