import java.io.*;

class Main {
    public static void main(String[] args) {
        try {
//
            File temp = File.createTempFile("jcl", ".out");

            // Make sure it gets deleted when we're done
            temp.deleteOnExit();

            // Print out file name and its last modified time
            long mod = temp.lastModified();
            System.out.println(temp + ":" + mod);

            // Introduced some delay
            try {
                Thread.sleep(3000);
            } catch (InterruptedException ie) {
            };

            // Write something out to file
            FileWriter fout = new FileWriter(temp);
            fout.write("hello");
            fout.close();

            System.out.println(temp + ":" + temp.lastModified());

            // Change modified date back to original
            if (temp.setLastModified(mod)) {
                System.out.println(temp + ":" + temp.lastModified());
            } else {
                System.out.println("modification time unchanged");
            }
//
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
