import java.lang.ref.*;
import java.io.*;
import java.util.*;

class Main {
    public static void main(String[] args) throws IOException {
        Object o = new Object();
        (new WatcherThread(o)).start();

        // Wait a few seconds before making o unused.
        try {
            Thread.sleep(5000);
        } catch (Exception e) {
            e.printStackTrace();
        }
        o = null;

        // Use all available memory to force a garbage-collection.
        eatMemory(new LinkedList());
    }
    static void eatMemory(LinkedList l) {
        try {
            l.add(new double[100000]);
            eatMemory(l);
        } catch (OutOfMemoryError e) {
            System.out.println("**** OUT OF MEMORY ****");
            l.clear();
            System.gc();
        }
    }
}

class WatcherThread extends Thread {
    WeakReference wr;

    public WatcherThread(Object o) {
        wr = new WeakReference(o);
    }
    
    public void run() {
        try {
            while (wr.get() != null) {
                // Do some work here.
                System.out.println("working...");

                Thread.sleep(2000);
            }
            System.out.println("done.");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
