class Main {
    static InheritableThreadLocal thrloc = new InheritableThreadLocal() {
        public Object childValue(Object parentVal) {
            System.out.println("cv " + thrloc.get());    // 3: "cv MainThread"
            return parentVal + "-2";
        }
    };

    Main() {
        System.out.println(thrloc.get());                // 1: "null"
        thrloc.set("MainThread");
        System.out.println(thrloc.get());                // 2: "MainThread"

        Thread t = new MyThread();
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        System.out.println(thrloc.get());                // 7: "MainThread"
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MyThread extends Thread {
    public MyThread() {
        System.out.println("c " + Main.thrloc.get());    // 4: "c MainThread"
    }
    public void run() {
        System.out.println(Main.thrloc.get());           // 5: "MainThread-2"
        Main.thrloc.set("MyThread");
        System.out.println(Main.thrloc.get());           // 6: "MyThread"
    }
}
