import java.net.*;
import java.io.*;

// START main1
class EchoServer extends Thread {
    private DatagramSocket sock = null;
    EchoServer(int port) {
	try {
	    sock = new DatagramSocket(port);
	} catch (SocketException e) {
	    e.printStackTrace();
	}
    }
    public void run() {
	if (sock == null)
	    return;

	byte[] inbuf = new byte[1024];
	DatagramPacket request = new DatagramPacket(inbuf, inbuf.length);
	try {
	    while (true) {
		sock.receive(request);
		sock.send(request); // just return what was sent
	    }
	} catch (IOException e) {
	    e.printStackTrace();
	}
    }
}
// END main1

class Main {
    static int echo_port = 1257;

// START main2
public static void echo(String msg, DatagramSocket client) {
    byte[] inbuf = new byte[1024];  // default size
    byte[] outbuf = msg.getBytes();

    try {
	// When constructing packet, don't need destination
	DatagramPacket request = new DatagramPacket(outbuf, outbuf.length);
	DatagramPacket reply = new DatagramPacket(inbuf, inbuf.length);
	client.send(request);
	client.receive(reply);
	client.close();
	System.out.println(new String(reply.getData()));
    } catch (SocketException e) {
	e.printStackTrace();
    } catch (IOException e) {
	e.printStackTrace();
    }
}
// END main2 

//
    public static void main(String[] args) {
	if (args.length != 1) {
	    System.err.println("Usage: java Main <message>");
	    System.exit(1);
	}

	// start server
	EchoServer srv = new EchoServer(echo_port);
	srv.setDaemon(true);
	srv.start();

	try {
	    InetAddress dst = InetAddress.getLocalHost();
	    DatagramSocket dest = new DatagramSocket();
	    dest.connect(dst, echo_port);

	    System.out.println("remote addr: " + dest.getInetAddress());
	    System.out.println("remote port: " + dest.getPort());

	    echo(args[0], dest);

	    dest.disconnect();

	    System.out.println("disconnected addr: " + dest.getInetAddress());
	    System.out.println("disconnected port: " + dest.getPort());

	} catch (UnknownHostException e) {
	    System.err.println("Host not found: " + e);
	} catch (SocketException e) {
	    e.printStackTrace();
	}
    }
//
}



