import java.net.*;
import java.util.jar.*;
import java.util.Map;
import java.util.Iterator;
import java.util.Set;

public class Main {
    public static void main(String[] args) {
        try {
            URL url = new URL("jar:file:showfiles.jar!/");
            JarURLConnection jconn = (JarURLConnection)url.openConnection();

            System.out.println("JAR File URL: " + jconn.getJarFileURL());
                                                        // file:showfiles.jar
            System.out.println("JAR File: " + jconn.getJarFile());

            System.out.println("JAR Entry: " + jconn.getEntryName());
                                                        // null (not an entry)

            // Get manifest and print names of entries it contains
            Manifest man = jconn.getManifest();
            if (man != null) {
                System.out.println("Entries: " );
                for (Iterator it = man.getEntries().keySet().iterator(); 
                     it.hasNext();) {
                    System.out.println(it.next());
                }
            }

            // Print main attributes of JAR file
            Attributes attrs = jconn.getMainAttributes();
            System.out.println("Main Attributes: " );
            if (attrs != null) {
                Set set = attrs.entrySet();
                for (Iterator it = set.iterator(); it.hasNext();) {
                    System.out.println(it.next());
                }
            }
        } catch (java.io.IOException e) {
            e.printStackTrace();
        }
    }
}
