import java.util.*;

class Main {
    public static void main(String[] args) {
        // c is unsynchronized, so these 3 lines would result in a
        // ConcurrentModificationException.
        // Collection c = new ArrayList();
        // new Writer(c).start();
        // new Reader(c).start();

        // sc is synchronized
        Collection sc = Collections.synchronizedCollection(new ArrayList());
        new Writer(sc).start();
        new Reader(sc).start();
    }
}

class Reader extends Thread {
    Collection col;
    Reader(Collection c) {
        col = c;
    }
    public void run() {
        while (true) {
            synchronized(col) {
                for (Iterator i=col.iterator(); i.hasNext(); ) {
                    System.out.print(i.next()+" ");
                    Thread.yield();
                }
                System.out.println();
            }
        }
    }
}

class Writer extends Thread {
    static Random rnd = new Random();
    Collection col;
    Writer(Collection c) {
        col = c;
    }
    public void run() {
        while (true) {
            Integer ri = new Integer(rnd.nextInt(10));
            if (rnd.nextBoolean()) {
                col.add(ri);
            } else {
                col.remove(ri);
            }
            Thread.yield();
        }
    }
}
