import java.math.*;
import java.util.*;

class Main {
    public static void main(String[] args) {
//
        TimeZone tz = TimeZone.getTimeZone("PST");
        System.out.println( tz.getDisplayName() );               
            // Pacific Standard Time
        
        // If the display name is not available in the desired locale,
        // the default display name is returned.
        System.out.println( tz.getDisplayName(Locale.CHINESE) ); // GMT-08:00

        // Print the display name variants for PST.
        System.out.println( tz.getDisplayName(false, TimeZone.SHORT) );
            // PST
        System.out.println( tz.getDisplayName(false, TimeZone.LONG) );
            // Pacific Standard Time
        System.out.println( tz.getDisplayName(true, TimeZone.SHORT) );
            // PDT
        System.out.println( tz.getDisplayName(true, TimeZone.LONG) );
            // Pacific Daylight Time

        // Print the display name variants for PST using an unsupported locale.
        System.out.println( tz.getDisplayName(false, TimeZone.SHORT, Locale.CHINESE));
            // GMT-08:00
        System.out.println( tz.getDisplayName(false, TimeZone.LONG, Locale.CHINESE) );
            // GMT-08:00
        System.out.println( tz.getDisplayName(true, TimeZone.SHORT, Locale.CHINESE) );
            // GMT-07:00
        System.out.println( tz.getDisplayName(true, TimeZone.LONG, Locale.CHINESE) );
            // GMT-07:00
//
    }
}
