import java.util.*;

class Main {
    public static void main(String[] args) {
        Vector v = new Vector(Arrays.asList(new String[]{"dog", null}));

        Object[] objs = v.toArray();
        print(objs);                         // [dog, null]

        // If we passed in a string array, we can cast
        // the result to a string array.
        String[] strings = (String[])v.toArray(new String[0]);
        print(strings);                      // [dog, null]

        // Try adding something other than a string to the vector.
        v.add(new Integer(0));

        print( v.toArray() );                // [dog, null, 0]

        // The Integer object can not be stored in the string array.
        //print( v.toArray(new String[0]) ); // ArrayStoreException
    }

    static void print(Object[] arr) {
        System.out.println(Arrays.asList(arr));
    }
}
