import java.util.*;
import java.util.jar.*;

class Main {
    public static void main(String[] args) {
//
        Attributes attr = new Attributes();
        attr.putValue("dog", "spot");
        attr.putValue("cat", "luck");
        attr.putValue("pig", "spot");

        Collection c = attr.values();

        // Remove an attribute with the value "spot".
        c.remove("spot");
        print( attr );                               // {cat=luck, pig=spot}

        // Remove all attributes with the value "spot".
        for (Iterator it=c.iterator(); it.hasNext(); ) {
            String v = (String)it.next();

            if (v.equals("spot")) {
                it.remove();
            }
        }
        print( attr );                               // {cat=luck}
            
        // Add to the attributes map and check the collection
        attr.put("yak", "yolk");
        System.out.println( c );                     // [luck, yolk]

        // You can't add to the collection
        c.add("bess");                               // UnsupportedOperationException

        // Note: see the class example for the implementation of print().
//
    }
    static void print(Attributes a) {
        System.out.print("{");
        boolean first = true;
        for (Iterator it=a.keySet().iterator(); it.hasNext(); ) {
            if (first) {
                first = false;
            } else {
                System.out.print(", ");
            }
            Object key = it.next();
            System.out.print(key+"="+a.get(key));
        }
        System.out.print("}\n");
    }
}
